//******************************************************************************
//*   Copyright (C) 2018 K. Vasudevan. Indian Institute of Technology Kanpur.
//*   All Rights Reserved.
//******************************************************************************
// MAP (BCJR) algorithm for decoder 2.
// Code tested on SCILAB ver 6.0.0.
//******************************************************************************
function[Prob]= Dec2_Process_End(Prob)
//******************************************************************************
// Initialize alpha and beta.
//******************************************************************************
 my_alpha=zeros(OFDM_SIZE,NUM_RX/2,NUM_STATES);
 my_beta=zeros(OFDM_SIZE+1,NUM_RX/2,NUM_STATES);
 my_alpha(1,:,:)=1.0;
 my_beta(OFDM_SIZE+1,:,:)=1.0;
//******************************************************************************
// Compute alpha and beta for decoder 2.
//******************************************************************************
 for time=1:OFDM_SIZE-1
  iv_tima=Div_Map(time);
  iv_timb=Div_Map(OFDM_SIZE+1-time);
//******************************************************************************
// Alpha beta recursion.
//******************************************************************************
  my_alpha(time+1,:,:)=my_alpha(time,:,P_State(:,1)).* ...
                       My_Gamma2(time,:,Ga_Inx(:,1)).* ...
                       Prob(iv_tima,:,P_Ip(:,1))+ ...
                       my_alpha(time,:,P_State(:,2)).* ...
                       My_Gamma2(time,:,Ga_Inx(:,2)).* ...
                       Prob(iv_tima,:,P_Ip(:,2));
  my_beta(OFDM_SIZE+1-time,:,:)=my_beta(OFDM_SIZE+2-time,:,N_State(:,1)).* ...
                                My_Gamma2(OFDM_SIZE+1-time,:,Gb_Inx(:,1)).* ...
                                repmat(Prob(iv_timb,:,1),...
                                1,1,NUM_STATES)+ ...
                                my_beta(OFDM_SIZE+2-time,:,N_State(:,2)).* ...
                                My_Gamma2(OFDM_SIZE+1-time,:,Gb_Inx(:,2)).* ...
                                repmat(Prob(iv_timb,:,2),...
                                1,1,NUM_STATES);
//******************************************************************************
// Normalize alpha and beta.
//******************************************************************************
  my_alpha(time+1,:,:)=my_alpha(time+1,:,:)./ ...
                       repmat(sum(my_alpha(time+1,:,:),3),1,1,NUM_STATES);
  my_beta(OFDM_SIZE+1-time,:,:)=my_beta(OFDM_SIZE+1-time,:,:)./ ...
                                repmat(sum(my_beta(OFDM_SIZE+1-time,:,:),3),...
                                1,1,NUM_STATES);
 end
//******************************************************************************
// Compute the a posteriori probabilities (APPs).
//******************************************************************************
 Prob(Div_Map(:),:,1)=sum(my_alpha.*my_beta(2:OFDM_SIZE+1,:,N_State(:,1)).* ...
                      My_Gamma2(:,:,Gb_Inx(:,1)).* ...
                      repmat(Prob(Div_Map(:),:,1),1,1,NUM_STATES),3);
 Prob(Div_Map(:),:,2)=sum(my_alpha.*my_beta(2:OFDM_SIZE+1,:,N_State(:,2)).* ...
                      My_Gamma2(:,:,Gb_Inx(:,2)).* ...
                      repmat(Prob(Div_Map(:),:,2),1,1,NUM_STATES),3);
 tmp_sum=sum(Prob,3);
 Prob=Prob./repmat(tmp_sum,1,1,NUM_INPUTS);
endfunction
