//******************************************************************************
//*   Copyright (C) 2018 K. Vasudevan. Indian Institute of Technology Kanpur.
//*   All Rights Reserved.
//******************************************************************************
// Get coded QPSK symbols. Data goes to real part, parity goes to the
// imaginary part.
// Code tested on SCILAB ver 5.5.2.
//******************************************************************************
function[my_code,my_data]=Get_Coded_QPSK()
 re_sym=int(2*grand(OFDM_SIZE,NUM_TX/2,'def'));
 iv_sym=re_sym(Div_Map(:),:);                               // Interleaved bits.
 sym=[re_sym iv_sym];
 sym1=[sym;zeros(OFDM_SIZE-1,NUM_TX)];
 par1=round(convol(RSC_Gen_Vec,sym1(:)));
 par2=matrix(par1(1:(2*OFDM_SIZE-1)*NUM_TX),2*OFDM_SIZE-1,NUM_TX);
 par3=modulo(matrix(par2(1:OFDM_SIZE,:),OFDM_SIZE,NUM_TX),2);
//******************************************************************************
// Data: real part; parity: imaginary part.
//******************************************************************************
 my_code=[1-2*sym(OFDM_Div_Map(:),:)+%i*(1-2*par3(OFDM_Div_Map(:),:))];
 my_data=1-2*sym;
endfunction
//******************************************************************************
