//******************************************************************************
//*   Copyright (C) 2011 K. Vasudevan. Indian Institute of Technology Kanpur.
//*   All Rights Reserved.
//******************************************************************************
// Get the trellis. State convention: Input side is MSB.
// Code tested on SCILAB ver 6.0.0.
//******************************************************************************
function[N_State,P_State,P_Ip,Op,Ga_Inx,Gb_Inx]=Get_Trellis()
 N_State=zeros(NUM_STATES,NUM_INPUTS);
 P_State=zeros(NUM_STATES,NUM_INPUTS);
 P_Ip=zeros(NUM_STATES,NUM_INPUTS);
 Op=zeros(NUM_STATES,NUM_INPUTS);
 Ga_Inx=zeros(NUM_STATES,NUM_INPUTS);      // Gamma indices for alpha recursion.
 Gb_Inx=zeros(NUM_STATES,NUM_INPUTS);       // Gamma indices for beta recursion.
 for state=1:NUM_STATES
  st_inx(state)=1;
 end
 for state=0:NUM_STATES-1
  for ip=0:NUM_INPUTS-1
   y=strtod(strsplit(dec2bin(state,RSC_MEM)));               // State in binary.
   y0=ip;
   for i=1:RSC_MEM
    y0=bitxor(y0,y(i)*DC(i+1));
   end
   t_op=y0*NC(1);
   for i=1:RSC_MEM
    t_op=bitxor(t_op,y(i)*NC(i+1));
   end
   Op(state+1,ip+1)=t_op;
   Gb_Inx(state+1,ip+1)=2*ip+t_op+1;
   for i=RSC_MEM:-1:2
    y(i)=y(i-1);
   end
   y(1)=y0;
   n_st=bin2dec(strcat(string(y)))+1;
   N_State(state+1,ip+1)=n_st;
   P_State(n_st,st_inx(n_st))=state+1;
   P_Ip(n_st,st_inx(n_st))=ip+1;
   Ga_Inx(n_st,st_inx(n_st))=2*ip+t_op+1;
   st_inx(n_st)=st_inx(n_st)+1;
  end
 end
endfunction
